<html>
	<head>
		<title>JavaScript: Example 7 (Modify CSS properties)</title>			
	</head>
	<body>
		<table id="students_table" border="1">
			<thead id="students_thead">
				<tr>
			    	<th colname="matricola" >MATRICOLA</th>
			    	<th colname="codice_persona">CODICE_PERSONA</th> 
			    	<th colname="nome">NOME</th>
			    	<th colname="cognome">COGNOME</th>
			    	<th colname="anno_inscrizione">ANNO_ISCRIZIONE</th>
			  	</tr>
		  	</thead>
		  	<tbody id="students_tbody">
		  	</tbody>
		</table>

		<button id="resetBtn">Reset</button>

		<script>

			students = [{'matricola': 11122, 'codice_persona': 15000, 'nome': 'Michele', 
						'cognome': 'Conti', 'anno_inscrizione': 2015},
						{'matricola': 45332, 'codice_persona': 29403, 'nome': 'Ana',
						'cognome': 'Totti', 'anno_inscrizione': 2016},
						{'matricola': 10100, 'codice_persona': 12024, 'nome': 'Fabio', 
						'cognome': 'Coscarelli', 'anno_inscrizione': 2014},
						{'matricola': 35522, 'codice_persona': 35300, 'nome': 'Federico', 
						'cognome':'Delucchi', 'anno_inscrizione': 2016}];

			originalColumns = ['matricola', 'codice_persona','nome','cognome','anno_inscrizione']; 
			hiddenColumns = [];
			sortProperty = 'matricola';

			function populateTableHeader(){
				var students_thead = document.getElementById("students_thead");

				// Clean table headers
				while(students_thead.hasChildNodes()){
   					students_thead.removeChild(students_thead.firstChild);
				}

				// Populate table headers with columns that were not hidden
				for (var i = 0; i < originalColumns.length; i++){
					var column = originalColumns[i];
					if (!hiddenColumns.includes(column)){
						var header = document.createElement("th");
						header.textContent = column.toUpperCase();
						header.setAttribute("colname",column);
						var btn1 = document.createElement("button");
						btn1.textContent = "^";
					    btn1.addEventListener("click", sortTable);
						header.append(btn1);
						var btn2 = document.createElement("button");
						btn2.textContent = "-";
						btn2.addEventListener("click", hideColumn);
						header.append(btn2);
						students_thead.append(header);
					}	
				}
			}

			function populateTableBody(){
				var students_tbody = document.getElementById("students_tbody");

				// Clean table body
				while(students_tbody.hasChildNodes()){
   					students_tbody.removeChild(students_tbody.firstChild);
				}

				// Sort table
				students.sort(function(obj1, obj2) {
					if (obj1[sortProperty] === obj2[sortProperty]) return 0;
					return obj1[sortProperty] > obj2[sortProperty] ? 1 : -1;
				})

				// Populate table body with columns that were not hidden
				for (var i = 0; i < students.length; i++){
					var student = students[i];
					var tr = document.createElement("tr");
					for (var j = 0; j < originalColumns.length; j++){
						var column = originalColumns[j];
						if (!hiddenColumns.includes(column)){
							var cell = document.createElement("td");
							cell.textContent = student[column];
							cell.setAttribute("colname",column);
							tr.append(cell);
						}
					}
					students_tbody.append(tr);
				}
			}

			function sortTable(){
				sortProperty = this.parentElement.getAttribute("colname");
				populateTableBody();
			}

			function hideColumn(){
				var colProperty = this.parentElement.getAttribute("colname");
				hiddenColumns.push(colProperty);
				populateTableHeader();
				populateTableBody()
			}

			function resetTable(){
				hiddenColumns = [];
				sortProperty = "matricola";
				populateTableHeader();
				populateTableBody();
			}	

			var resetBtn = document.getElementById("resetBtn");
			resetBtn.addEventListener("click", resetTable);
			resetTable();

		</script>
	</body>
</html>